package vplotter;

public class MovementMsg {
	private double leftChange;
	private double rigthChange;
	private boolean invertLeft;
	private boolean invertRight;
	
	public double getLeftChange() {
		return leftChange;
	}

	public void setLeftChange(double sizeLeft) {

		this.leftChange = sizeLeft;
	}

	public double getRigthChange() {
		return rigthChange;
	}


	public void setRigthChange(double sizeRigth) {
		this.rigthChange = sizeRigth;
	}



	public String getStringMsg(){
		StringBuffer sb = new StringBuffer();
		sb.append('m');
		boolean positiveLeft = isPositiveLeft();
		if(isInvertLeft()){
			positiveLeft =!positiveLeft;
		}
		
		if(positiveLeft){
			sb.append('p');
		}else{
			sb.append('n');
		}
		sb.append((char)Math.abs(this.leftChange/256));
		sb.append((char)Math.abs(this.leftChange%256));
		
		
		boolean positiveRigth = isPositiveRigth();
		if(isInvertRight()){
			positiveRigth =!positiveRigth;
		}
		if(positiveRigth){
			sb.append('p');
		}else{
			sb.append('n');
		}
		sb.append((char)Math.abs(this.rigthChange/256));
		sb.append((char)Math.abs(this.rigthChange%256));
		
		return sb.toString();
	}

	private boolean isPositiveLeft() {
		return this.leftChange>=0;
	}

	private boolean isPositiveRigth() {
		return this.rigthChange>=0;
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		
		String msg = this.getStringMsg();
		for (int i = 0; i < msg.length(); i++) {
			char c = msg.charAt(i);
			if(c == 'm' || c == 'n' || c == 'p' || c == 'e'){
				sb.append(c);
			}else{
				sb.append((int)c);
				sb.append(',');
			}
		}
		sb.append("\n");
		return sb.toString();
	}



	public boolean isInvertLeft() {
		return invertLeft;
	}



	public void setInvertLeft(boolean invertLeft) {
		this.invertLeft = invertLeft;
	}



	public boolean isInvertRight() {
		return invertRight;
	}



	public void setInvertRight(boolean rightLeft) {
		this.invertRight = rightLeft;
	}

	
}
