package vplotter;
import java.util.ArrayList;
import java.util.List;

import vplotter.VPlotter;
import vplotter.model.Line;
import vplotter.model.Point;


public class Tests {
	
	public static VPlotter vp = new VPlotter();
	
	public static void main(String[] args) {
		vp.setInvertA(true);
		vp.setInvertB(false);
//		testMotorMovement();
		testDesenhoLinhaHorizontal();
		
	}

	private static void testMotorMovement() {
			MovementMsg mm = new MovementMsg();
			mm.setRigthChange(250);
			mm.setLeftChange(0);
			vp.sendToPlotter(mm);
			
			mm = new MovementMsg();
			mm.setRigthChange(-250);
			mm.setLeftChange(0);
			vp.sendToPlotter(mm);
			
			mm = new MovementMsg();
			mm.setRigthChange(0);
			mm.setLeftChange(250);
			vp.sendToPlotter(mm);
			
			mm = new MovementMsg();
			mm.setRigthChange(0);
			mm.setLeftChange(-250);
			vp.sendToPlotter(mm);
	}
	
	public static void testDesenhoLinhaHorizontal(){
		List<Line> lines = new ArrayList<Line>();
		lines.add(new Line(new Point(0,0),new Point(100,100)));
		vp.printLines(lines);
		System.exit(1);
	}
	
	public static void testDesenhoLinhaVertical(){
		List<Line> lines = new ArrayList<Line>();
		lines.add(new Line(new Point(0,0),new Point(0,100)));
		vp.printLines(lines);
		System.exit(1);
	}
	public static void testDesenhoLinhaDiagonal(){
		List<Line> lines = new ArrayList<Line>();
		lines.add(new Line(new Point(0,0),new Point(100,100)));
		vp.printLines(lines);
		System.exit(1);
	}
}
